<%@page language="java" isErrorPage="true" import="java.io.*,com.infoengine.util.*,com.infoengine.exception.*,com.infoengine.exception.fatal.*,com.infoengine.exception.nonfatal.*,java.util.Hashtable"
%><%@ taglib uri="http://www.ptc.com/infoengine/taglib/core" prefix="ie"
%><%!
  public String htmlEncode ( String text ) {
    if ( text == null ) return "";
    StringBuffer sb = new StringBuffer ();

    for ( int i = 0; i < text.length(); i++ ) {
      char c = text.charAt ( i );
      switch ( c ) {
        case '"': {
          sb.append ( "&quot;" );
          break;
        }
        case '<': {
          sb.append ( "&lt;" );
          break;
        }
        case '>': {
          sb.append ( "&gt;" );
          break;
        }
        case '&': {
          sb.append ( "&amp;" );
          break;
        }
        case '\'': {
          sb.append ( "&rsquo;" );
          break;
        }
        case '`': {
          sb.append ( "&lsquo;" );
          break;
        }
        default: {
          sb.append ( c );
          break;
        }
      }
    }
    return sb.toString();
  }
%><%
  // do initialization
  String title = null;              // page title
  String heading = null;            // page heading
  String message = null;            // main error message
  String extra = null;              // supplemental error message
  boolean printStackTrace = false;  // print stack trace to page or no

  if ( exception instanceof IEFatalException ) {

    heading = "An Info*Engine Fatal Error has occurred";
    title = "Info*Engine Fatal Error";
    if ( exception instanceof IEFatalServiceException ) {
      heading = heading + " (Service Error)";
    } else if ( exception instanceof IEFatalClientException ) {
      heading = heading + " (Client Error)";
    }

    // get supplemental error message
    String prefix = "com.infoengine.exception.fatal.";
    Hashtable msgs = new Hashtable ();
    msgs.put ( prefix+"IEBadRequestException", "Bad Request" );
    msgs.put ( prefix+"IEFatalServiceUnavailableException", "Service Unavailable" );
    msgs.put ( prefix+"IEForbiddenException", "Forbidden" );
    msgs.put ( prefix+"IEInternalServiceException", "Internal Service Error" );
    msgs.put ( prefix+"IENotFoundException", "Not Found" );
    msgs.put ( prefix+"IESyntaxException", "Syntax Error" );
    msgs.put ( prefix+"IEUnauthorizedException", "Unauthorized" );
    msgs.put ( prefix+"IERemoteException", "Remote Error" );
    msgs.put ( "com.infoengine.procunit.adapter.AdapterException", "Adapter Error" );
    msgs.put ( prefix+"IETaskCompilerException", "Task Compiler Error" );
    msgs.put ( prefix+"IENotResumableException", "Not Resumable Error" );

    extra = (String)msgs.get ( exception.getClass().getName() );
    if ( extra == null )
      extra = "Unknown Error";

  } else if ( exception instanceof IETemporaryException ) {

    heading = "An Info*Engine Temporary Error has occurred";
    title = "Info*Engine Temporary Error";

    // get supplemental error message
    String prefix = "com.infoengine.exception.nonfatal.";
    Hashtable msgs = new Hashtable ();
    msgs.put ( prefix+"IERequestTimeOutException", "Request Timed Out" );
    msgs.put ( prefix+"IEServiceUnavailableException", "Service Unavailable" );

    extra = (String)msgs.get ( exception.getClass().getName() );
        if ( extra == null )
      extra = "Unknown Error";

  } else if ( exception instanceof IEPartialResultsException ) {

    heading = "Info*Engine Returned Partial Results";
    title = "Info*Engine Partial Results";

  } else if ( exception instanceof IEException ) {

    heading = "Info*Engine Error";
    title = "Info*Engine Error";

  } else {

    // some other JspException was thrown
    heading = "Error";
    title = "Error";

  }

  // get main message out of exception
  if ( exception instanceof IEException ) {
    message = ((IEException)exception).getLocalizedMessage();
  } else {
    message = exception.getMessage ();
    printStackTrace = true;
  }

  message = htmlEncode ( message );

%>
<html>
<head><title><%=title%></title></head>
<body bgcolor=#CECCC0 topmargin=8 bottommargin=8 leftmargin=8 rightmargin=8>

<table border=1 width=100% height=100%>
<tr><td bgcolor=#ffffff valign=top align=center>

<table><tr><td>

  <h2><%=heading%></h2>

<%
  if ( extra != null ) {
    %><!-- supplemental error message table -->
    <table border=1><tr><td bgcolor=#cccccc>&nbsp;
      <strong><%=extra%></strong>
    &nbsp;</td></tr></table><br><%
  }
%>

  <h3>Message</h3>
  <!-- error message table -->
  <table border=1><tr><td bgcolor=#cccccc>&nbsp;
    <%=message%>
  &nbsp;</td></tr></table>

<%
  if ( exception instanceof IEPartialResultsException ) {
    %><br>
    <h3 color=navy>The partial results returned are</h3>
    <%
      com.infoengine.object.IeCollection vdb = ((IEPartialResultsException)exception).getCollection ();
      vdb.setStatus ( 0 );
    %><ie:getService varName="service"/><%
      service.setCollection ( vdb );
    %><ie:webject name="Display-Table" type="DSP"/><%
  }


  while ( exception != null ) {
    out.println ( "<br><h3>Stack Trace</h3>" );
    out.println ( "<font style=\"font-size: x-small\">" );
    StringWriter sw = new StringWriter ();
    exception.printStackTrace (new PrintWriter (sw));
    String stackTrace = sw.toString();
    java.util.StringTokenizer st = new java.util.StringTokenizer ( sw.toString(), "\r\n" );
    boolean first = true;
    while ( st.hasMoreTokens () ) {
      if ( !first )
        out.println ( "&nbsp;&nbsp;&nbsp;" + htmlEncode ( st.nextToken() ) + "<br>" );
      else {
        out.println ( htmlEncode ( st.nextToken() ) + "<br>" );
        first = false;
      }
    }
    out.println ( "</font><br>" );
    if ( exception instanceof IEException )
      exception = (Throwable)((IEException)exception).getNestedThrowable ();

    else
      break;

  }

%>
</td></tr></table>

</td></tr></table>

</body>
</html>
