<!-- WTDocAssoc.jsp: Associate WTParts and WTDocuments given a list. A WTPart Described By link is created.
The input list is a csv file with two values per line: wtpart number, wtdoc number. The csv file WTDocAssoc.csv
at <WT_HOME>\codebase is used. This jsp should be located under <WT_HOME>\codebase\wtcore\jsp. -->
<%@page language="java" session="false" errorPage="IEError.jsp"
   import="com.infoengine.object.factory.*,
           com.infoengine.object.*,
           wt.fc.*,
           wt.part.*,
           wt.doc.*,
           wt.epm.build.*,
           java.util.*,
           wt.vc.wip.*,
           java.io.*,
           wt.epm.structure.*,
           wt.folder.*"
%>

<%@ page import="java.io.*,java.util.*, javax.servlet.*" %>
<%@ page import="javax.servlet.http.*" %>
<%@ page import="org.apache.commons.fileupload.*" %>
<%@ page import="org.apache.commons.fileupload.disk.*" %>
<%@ page import="org.apache.commons.fileupload.servlet.*" %>
<%@ page import="org.apache.commons.io.output.*" %>
<%@ page import="org.apache.commons.lang.*" %>

<%@taglib uri="http://www.ptc.com/infoengine/taglib/core" prefix="ie" %>

<%
// Upload WTDocAssoc.csv to server
// Overwrites existing file with same name
// csv file should contain one or more lines of the format
// wtpart number, WTDoc number

File file ;
int maxFileSize = 5000 * 1024;
int maxMemSize = 5000 * 1024;
ServletContext context = pageContext.getServletContext();
String filePath = "D:\\PTC\\Windchill_10.2\\Windchill\\codebase\\";
boolean fileUploaded = false;

// Verify the content type
String contentType = request.getContentType();

if ((contentType.indexOf("multipart/form-data") >= 0)) {
  DiskFileItemFactory factory = new DiskFileItemFactory();
  // maximum size that will be stored in memory
  factory.setSizeThreshold(maxMemSize);
  // Location to save data that is larger than maxMemSize.
  factory.setRepository(new File("c:\\temp"));

  // Create a new file upload handler
  ServletFileUpload upload = new ServletFileUpload(factory);
  // maximum file size to be uploaded.
  upload.setSizeMax( maxFileSize );
  try{
	 // Parse the request to get file items.
	 List fileItems = upload.parseRequest(request);

	 // Process the uploaded file items
	 Iterator i = fileItems.iterator();
	 while ( i.hasNext () ) 
	 {
		FileItem fi = (FileItem)i.next();
		if ( !fi.isFormField () )	{
			// Get the uploaded file parameters
			String fieldName = fi.getFieldName();
			String fileName = fi.getName();
			boolean isInMemory = fi.isInMemory();
			long sizeInBytes = fi.getSize();
			// Write the file
			if (fileName.endsWith("WTDocAssoc.csv")) {
				if( fileName.lastIndexOf("\\") >= 0 ){
				file = new File( filePath + fileName.substring( fileName.lastIndexOf("\\"))) ;
				file = new File( filePath + "WTDocAssoc.csv");
				}else{
				file = new File( filePath + fileName.substring(fileName.lastIndexOf("\\")+1)) ;
				}
				fi.write( file ) ;
				out.println(fileName + " uploaded to server" + "<br>");
				fileUploaded = true;
			}else{
				out.println("Filename must be WTDocAssoc.csv" + "<br>");
			}
		out.println("<br>");
		}
	 }
  }catch(Exception ex) {
	 System.out.println(ex);
  }
}

%>

<html>
<head>
<title>WTDoc Association</title>
</head>

<body bgcolor="#FFFFFF">

<ie:authenticate />
<ie:getService varName="ieObj" />

<%
//
// Start WTPart to WTDoc association based on WTDocAssoc.csv file 
//
if (fileUploaded) {
    java.net.URL url = config.getServletContext ().getResource ("WTDocAssoc.csv");
    BufferedReader buffreader = new BufferedReader (new InputStreamReader (url.openStream ()));

    String line = buffreader.readLine ();
    String[] lineparts = null;
    String wtpartnumber = new String();
    String docnumber = new String();

	File WTDocAssocLog = new File ("D:\\PTC\\Windchill_10.2\\Windchill\\logs\\WTDocAssoc.log");
	PrintWriter outLog = new PrintWriter (new BufferedWriter (new FileWriter (WTDocAssocLog, true)), true);
	outLog.print ("Associating WTParts to WTDocs ");
	
	Date today = new Date ();
	outLog.println (today);

    while (line != null) {
		int commas = StringUtils.countMatches(line, ",");
		if (commas == 1) {
			lineparts = line.split(",");
			wtpartnumber = "(number=\'" + lineparts[0].trim() + "\')";
			docnumber = "(name=\'" + lineparts[1].trim() + "\')";
%>

<B>Associating</B>: WTPart <%=wtpartnumber%> with WTDoc <%=docnumber%>...<BR>

<!-- Search the latest revision for all iterations -->
<ie:webject name="Search-Objects" type="OBJ">
  <ie:param name="ATTRIBUTE" data="obid"/>
  <ie:param name="ATTRIBUTE" data="version"/>
  <ie:param name="ATTRIBUTE" data="iteration"/>
  <ie:param name="GROUP_OUT" data="DOCALLLATEST"/>
  <ie:param name="INSTANCE" data="com.cat.mining.plm.Windchill"/>
  <ie:param name="ITERATION" data="ALL"/>
  <ie:param name="TYPE" data="wt.doc.WTDocument"/>
  <ie:param name="VERSION" data="LATEST"/>
  <ie:param name="WHERE" data="<%=docnumber%>"/>
</ie:webject>

<ie:webject name="Search-Objects" type="OBJ">
  <ie:param name="ATTRIBUTE" data="obid"/>
  <ie:param name="ATTRIBUTE" data="version"/>
  <ie:param name="ATTRIBUTE" data="iteration"/>
  <ie:param name="GROUP_OUT" data="PRTALLLATEST"/>
  <ie:param name="INSTANCE" data="com.cat.mining.plm.Windchill"/>
  <ie:param name="ITERATION" data="ALL"/>
  <ie:param name="TYPE" data="wt.part.WTPart"/>
  <ie:param name="VERSION" data="LATEST"/>
  <ie:param name="WHERE" data="<%=wtpartnumber%>"/>
</ie:webject>

<!-- Sort the search output descending by iteration -->
<ie:webject name="Sort-Group" type="GRP">
  <ie:param name="GROUP_IN" data="DOCALLLATEST"/>
  <ie:param name="SORTBY" data="iteration"/>
  <ie:param name="SORTED" data="DESC"/>
  <ie:param name="COMPARISON" data="NUMERIC"/>
  <ie:param name="GROUP_OUT" data="DOCALLSORTED"/>
</ie:webject>

<ie:webject name="Sort-Group" type="GRP">
  <ie:param name="GROUP_IN" data="PRTALLLATEST"/>
  <ie:param name="SORTBY" data="iteration"/>
  <ie:param name="SORTED" data="DESC"/>
  <ie:param name="COMPARISON" data="NUMERIC"/>
  <ie:param name="GROUP_OUT" data="PRTALLSORTED"/>
</ie:webject>

<!-- Extract just the latest iteration from the sort -->
<ie:webject name="Extract-Group" type="GRP">
  <ie:param name="EXTRACT" data="obid"/>
  <ie:param name="ELEMENT_COUNT" data="1"/>
  <ie:param name="EXTRACT_MODE" data="MATCH"/>
  <ie:param name="GROUP_IN" data="DOCALLSORTED"/>
  <ie:param name="GROUP_OUT" data="DOCLATEST"/>
</ie:webject>

<ie:webject name="Extract-Group" type="GRP">
  <ie:param name="EXTRACT" data="obid"/>
  <ie:param name="ELEMENT_COUNT" data="1"/>
  <ie:param name="EXTRACT_MODE" data="MATCH"/>
  <ie:param name="GROUP_IN" data="PRTALLSORTED"/>
  <ie:param name="GROUP_OUT" data="PRTLATEST"/>
</ie:webject>

<%
			Group docworkcopy = ieObj.getGroup("DOCLATEST");
			Group prtworkcopy = ieObj.getGroup("PRTLATEST");

			Enumeration enum1 = docworkcopy.getElements();
			Enumeration enum2 = prtworkcopy.getElements();

			//if enum1 or enum2 is out of elements, the wtpart or wtdoc doesn't exist
			if (enum1.hasMoreElements () && enum2.hasMoreElements ()) {
				Element elem1 = (Element) enum1.nextElement();
				Element elem2 = (Element) enum2.nextElement();

				String docObid = elem1.getAtt("obid").getValue().toString();
				String prtObid = elem2.getAtt("obid").getValue().toString();

				int colonLoc1 = docObid.indexOf(":", 3);
				int colonLoc2 = docObid.indexOf(":", colonLoc1 + 1);
				String docID = docObid.substring(colonLoc1 + 1, colonLoc2);
				docID = "wt.doc.WTDocument:" + docID;

				colonLoc1 = prtObid.indexOf(":", 3);
				colonLoc2 = prtObid.indexOf(":", colonLoc1 + 1);
				String prtID = prtObid.substring(colonLoc1 + 1, colonLoc2);
				prtID = "wt.part.WTPart:" + prtID;

				WTDocument OBJ_doc = (WTDocument)(new ReferenceFactory()).getReference(docID).getObject();
				WTPart OBJ_prt = (WTPart)(new ReferenceFactory()).getReference(prtID).getObject();

				QueryResult qrWTDocs = PersistenceHelper.manager.navigate (OBJ_prt, wt.part.WTPartDescribeLink.DESCRIBED_BY_ROLE, wt.part.WTPartDescribeLink.class);

				if ((!(WorkInProgressHelper.isCheckedOut (OBJ_doc))) &&
					(!(WorkInProgressHelper.isCheckedOut (OBJ_prt)))) {
					Folder coFolder = WorkInProgressHelper.service.getCheckoutFolder ();
					WorkInProgressHelper.service.checkout (OBJ_prt, coFolder, "");
					
					WTPart WRK_prt = (WTPart) WorkInProgressHelper.service.workingCopyOf (OBJ_prt);

					Link docpartlink = (Link) WTPartDescribeLink.newWTPartDescribeLink (WRK_prt, OBJ_doc);
					Link savedlink = (Link) PersistenceHelper.manager.save (docpartlink);

					WTPart CI_prt = (WTPart) WorkInProgressHelper.service.checkin (OBJ_prt, "");
				} else {
						%> <B>&nbsp;-Association skipped because Part or WTDoc is checked out.</B><BR><%
						outLog.println ("WTPart " + wtpartnumber + " NOT associated to WTDoc " + docnumber + " because part or WTDoc is checked out");
				}
			} else {
				%> <B>&nbsp;-Association skipped because Part or WTDoc doesn't exist.</B><BR><%
				outLog.println ("WTPart " + wtpartnumber + " NOT associated to WTDoc " + docnumber + " because part or WTDoc doesn't exist");
			}
			line = buffreader.readLine ();
		} else {
			%> <B>&nbsp;Check the line format of the WTDocAssoc.csv file.</B><BR><%
			%> <B>&nbsp;Each comma separated line should contain: </B><I>WTPart number, WTDoc number</I><BR><%
			break;
		}
	}
	buffreader.close ();
	outLog.close ();
}
%>

</body>
</html>